<?php
/**
* FlickrSetPlugin.class.php
* 
* Plugin zur Anzeige von Flickr Content
* 
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
* @version              $Id: FlickrSetPlugin.class.php,v 1.6 2006-10-10 17:24:00 jankul Exp $
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// statistics.php
// Copyright (C) 2006 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

require_once("phpFlickr/phpFlickr.php");


class FlickrSetPlugin extends AbstractStudIPHomepagePlugin {

	var $userid;
	var $username;


	function FlickrSetPlugin(){
		parent::AbstractStudIPHomepagePlugin();
		$this->initialize();
		$this->setPluginIconName('kamera.gif');
		$tab = new PluginNavigation();
		$tab->setActive();
		$tab->setDisplayname(_("Flickr-Sets"));
		$this->setNavigation($tab); 
	}
	
	function initialize() {
		if ($u = $this->getRequestedUser()) {
			$db = new DB_Seminar();
			$db->queryf("SELECT * FROM user_flickr WHERE user_id='%s' ORDER BY priority",$u->getUserId());
                	$this->setStatusShowOverviewPage(($db->num_rows() > 0 ? TRUE : FALSE));
		}
	}

	function setPluginpath($newpath){
		parent::setPluginpath($newpath);
		//$this->buildMenu();
	}
	
	/*function buildMenu(){
		$tab = new PluginNavigation();
		$tab->setDisplayname(_("Flickr-Sets"));
		$this->setNavigation($tab); 
	}*/

	function setRequestedUser($user) {
                parent::setRequestedUser($user);
		$this->initialize();
                /*$u = $this->getRequestedUser();
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM user_flickr WHERE user_id='%s' ORDER BY priority",$u->getUserId());
                $this->setStatusShowOverviewPage(($db->num_rows() > 0 ? TRUE : FALSE));*/
        }

	function mach_mir_den_flickr($open, $fl_name) {
	
		$user_id = $this->userid;

		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM user_flickr WHERE user_id='%s' ORDER BY priority",$user_id);

		// Create new phpFlickr object
		$f = new phpFlickr(get_config("FLICKR_API_KEY"),NULL,FALSE);

		while ($db->next_record()) {

			$fl_name = $db->f("flickr_user");
    			// Find the NSID of the username inputted via the form
    			$nsid = $f->people_findByUsername($fl_name);

			$photosets = $f->photosets_getList($nsid);
			$photos_url = $f->urls_getUserPhotos($nsid);

			if (is_array($photosets['photoset'])) {

				echo "<H3><A HREF=\"http://www.flickr.com/photos/$fl_name\" TARGET=\"fl_name\">$fl_name</A></H3>";

				echo "<TABLE CLASS=\"blank\" BORDER=\"0\" WIDTH=100% cellpadding=0 cellspacing=0>";

				foreach ($photosets['photoset'] as $sets) {
					$link = "$PHP_SELF?fl_name=$fl_name&open=".($open==$sets['id']?"":$sets['id'])."&username=".$this->username."#anker";
                			$icon = "<IMG SRC=\"".$this->getPluginpath()."/kamera.gif\" ALT=\"Flickr Set\">";
               				$tmp_titel=htmlReady(mila($sets['title']));
                			$tmp_titel = "<a href=\"$link\" class=\"tree\" >$tmp_titel</a>";
                			$titel= $tmp_titel."&nbsp;&nbsp;";
                       			$titel = "<A HREF=\"$PHP_SELF?username=".$this->username."&open=".($open==$sets['id']?"":$sets['id']."#anker")."\"><FONT SIZE=\"-1\">".htmlReady(mila($sets['title']))."</FONT></A>";
                			$zusatz = "<a href=\"about.php?fl_name=".get_username($user_id)."\"><font color=\"#333399\">".htmlReady(get_fullname($user_id))."</font></a>";

					echo "<TR>\n";
					echo "  <TD COLSPAN=\"2\" WIDTH=\"100%\">\n";
					echo "             <TABLE BORDER=\"0\" WIDTH=\"100%\" CELLPADDING=\"0\" CELLSPACING=\"0\">\n";
                			echo "               <TR>\n";
                			printhead ("100%", 0, $link, ($open==$sets['id']?"open":"close"), FALSE, $icon, $titel, $zusatz, time());
                			echo "               </TR>\n";
                			echo "             </TABLE>\n";
					echo "</TD></TR>";

					if ($open==$sets['id']) {
						echo "<A NAME=\"anker\">\n";
						echo "<TR CLASS=\"blank\"><TD WIDTH=\"1%\">&nbsp;</TD>\n";
						echo "  <TD WIDTH=\"95%\" ALIGN=\"CENTER\"><BR>\n";
						$photos = $f->photosets_getPhotos($sets['id']);
						$i = 0;
						if (strlen($sets['description'])>0) echo "<FONT SIZE=\"-1\"><I>".$sets['description']."</I></FONT><BR><BR>";
						foreach ($photos['photo'] as $photo) {
       							echo "<a href=\"$photos_url$photo[id]\" TARGET=\"flickr_foto\">";
       							echo "<img border='0' alt='$photo[title]' ".
       							"src=" . $f->buildPhotoURL($photo, "Square") . ">";
       							echo "</a>";
       							$i++;
       							// If it reaches the sixth photo, insert a line break
       							if ($i % 6 == 0) {
       								echo "<br>\n";
       							}
						}
						echo "<BR><BR></TD></TR>";
					}
				}
				echo "</TABLE>\n";
			}
		}
	}


	function print_flickr() {
	
		$db=new DB_Seminar;
		$cssSw=new cssClassSwitcher;
	
		$cssSw->switchClass();
	
		$db->queryf("SELECT * FROM user_flickr WHERE user_id='%s' ORDER BY priority",$this->userid);
	
		echo '<tr><td align="left" valign="top" class="blank"><blockquote><br />'. "\n";
		echo _("Hier knnen Sie eigene Flickr-Benutzer angeben. Die Flickr-Sets der Benutzer erscheinen dann auf der pers&ouml;nlichen Homepage.");
		echo "\n<br /><br /></blockquote></td></tr>\n".'<tr><td class="blank">';
		echo '<form action="'.PluginEngine::getLink($this,array("freie" => "update_freie", "username" => $this->username),"showAdministrationPage").'" method="POST" name="edit_freie">';
		echo '<table width="100%" class="blank" border="0" cellpadding="0" cellspacing="0">';
		if (!$db->num_rows())
			echo '<tr><td class="'.$cssSw->getClass().'"><font size="-1"><b><blockquote>' . _("Es existieren zur Zeit keine eigenen Flickr-Benutzer.") . "</blockquote></b></font></td></tr>\n";
		echo '<tr><td class="'.$cssSw->getClass().'"> <blockquote>' . _("Flickr-Benutzer") . '&nbsp; <a href="'.PluginEngine::getLink($this,array("freie" => "create_freie"), "showAdministrationPage").'">' . makeButton("neuanlegen") . "</a></blockquote></td></tr>\n";
		$count = 0;
		$hidden_count = 0;
		while ($db->next_record() ){
			$cssSw->switchClass();
			$id = $db->f("id");
			echo '<input type="hidden" name="flickr_ids[]" value="'.$db->f("id")."\">\n";
			echo '<tr><td class="'.$cssSw->getClass().'">';
			if ($count)
				echo "<br />\n";
			echo '<blockquote><input type="text" name="flickr_user[]" style="width: 50%" value="' . htmlReady($db->f("flickr_user")).'" size="40">';
			if ($count){
				echo "\n".'<a href="'.PluginEngine::getLink($this,array("freie" => "order_freie", "direction" => "up", "flickr_id" => $db->f("id")),"showAdministrationPage")
				. '"><img src="'. $GLOBALS['ASSETS_URL'] . 'images/move_up.gif" hspace="4" width="13" height="11" border="0" '
				. tooltip(_("Flickr nach oben verschieben")) .'></a>';
			}
			if (($count+$hidden_count) != ($db->num_rows()-1) ){
				echo "\n".'<a href="'.PluginEngine::getLink($this,array("freie" => "order_freie", "direction" => "down", "flickr_id" => $db->f("id")),"showAdministrationPage")
				. '"><img src="'. $GLOBALS['ASSETS_URL'] . 'images/move_down.gif" hspace="4" width="13" height="11" border="0" '
				. tooltip(_("Flick nach unten verschieben")) .'></a>';
			}
			echo "<br />\n&nbsp;</blockquote></td></tr>\n";
			echo '<TR class="'.$cssSw->getClass().'"><TD><blockquote><input type="IMAGE" name="update" border="0" align="absmiddle" ' . makeButton("uebernehmen", "src") . ' value="' . _("ver&auml;ndern") . '">';
			echo '&nbsp;<a href="'.PluginEngine::getLink($this,array("cmd" => "showAdministrationPage", "freie" => "delete_freie", "flickr_id" => $db->f("id")),"showAdministrationPage").'">';
			echo makeButton("loeschen") . "</a><br />\n&nbsp; </blockquote></td></tr>\n";
			$count++;
		}		
	
		echo '</td></tr></table></form></td></tr>'."\n";
	}
	
	function create() {
	
		$db=new DB_Seminar;
		$id=md5(uniqid("blablubburegds4"));
		$db->query("UPDATE user_flickr SET priority=priority+1 WHERE user_id='$this->userid'");
		$db->query("INSERT INTO user_flickr (user_id, flickr_user, priority, id) VALUES ('$this->userid', 'Flickr-Benutzer', 0, '$id')");
		if ($db->affected_rows() == 0) {
			parse_msg ("info" . _("Anlegen fehlgeschlagen"));
			die;
		}
	}
	
	function delete($flickr_id) {
	
		$db=new DB_Seminar;
		$db->query ("SELECT * FROM user_flickr WHERE user_id = '$this->userid' and id='$flickr_id'");
		if (!$db->next_record()) { //hier wollte jemand schummeln
			parse_msg ("info" . _("Netter Versuch, vielleicht beim n&auml;chsten Mal!"));
			die;
		} else {
			$db->query("DELETE FROM user_flickr WHERE user_id='$this->userid' AND id='$flickr_id'");
			if ($db->affected_rows() == 1) {
				parse_msg ("msg" . _("Flickr gel&ouml;scht!"));
			}
		}
	}
	
	function update($freie_id, $flickr_user) {
		$db = new DB_Seminar;
		$max = sizeof($freie_id);
		FOR ($i=0; $i < $max; $i++) {
			$flickr = $flickr_user[$i];
			$id = $freie_id[$i];
			if ($flickr === '') {
				parse_msg ('error' . _("Flickr ohne Namen k&ouml;nnen nicht gespeichert werden!"));
				continue;
			}
			$db->query("UPDATE user_flickr SET flickr_user='$flickr' WHERE id='$id'");
		}
		parse_msg ("msg" . _("Flickr ge&auml;ndert!"));
	}
	
	function order($flickr_id,$direction){
		$items_to_order = array();
		$db = new DB_Seminar("SELECT id FROM user_flickr WHERE user_id='$this->userid' ORDER BY priority");
		while($db->next_record()) {
			$items_to_order[] = $db->f("id");
		}
		for ($i = 0; $i < count($items_to_order); ++$i) {
			if ($flickr_id == $items_to_order[$i])
				break;
		}
		if ($direction == "up" && isset($items_to_order[$i-1])) {
			$items_to_order[$i] = $items_to_order[$i-1];
			$items_to_order[$i-1] = $flickr_id;
		} elseif (isset($items_to_order[$i+1])) {
			$items_to_order[$i] = $items_to_order[$i+1];
			$items_to_order[$i+1] = $flickr_id;
		}
		for ($i = 0; $i < count($items_to_order); ++$i) {
			$db->query("UPDATE user_flickr SET priority=$i WHERE id='$items_to_order[$i]'");
		}
		parse_msg("msg" . _("Flickr neu geordnet"));
	}
	

	function actionShow() {
		$GLOBALS['perm']->check('autor');
		$this->actionShowAdministrationPage();
	}

	function actionShowAdministrationPage(){
		$GLOBALS['perm']->check('autor');
		$u = new StudIPUser();
		$u = $this->getRequestedUser();
		$this->userid = $u->getUserId();
		$this->username = $u->getUsername();

		if ($this->userid == $GLOBALS['auth']->auth['uid']) {
		
			if ($this->userid != "") {
				if ($_REQUEST['freie'] == "create_freie") $this->create();
 	        		if ($_REQUEST['freie'] == "delete_freie") $this->delete($_REQUEST['flickr_id']);
       	 			if ($_REQUEST['freie'] == "update_freie") $this->update($_REQUEST['flickr_ids'], $_REQUEST['flickr_user']);
       				if ($_REQUEST['freie'] == "order_freie") $this->order($_REQUEST['flickr_id'], $_REQUEST['direction']);

				$this->print_flickr();
			}
		} else {
			echo "Zugriff verweigert!";
		}
	}

	function showOverview() {
		$this->actionShowOverview();
	}

	function actionShowOverview() {
		$GLOBALS['perm']->check('autor');
		$u = new StudIPUser();
		$u = $this->getRequestedUser();
		$this->userid = $u->getUserId();
		$this->username = $u->getUsername();

		$this->mach_mir_den_flickr($_REQUEST['open'], $_REQUEST['fl_name']);
		
	}

}

?>
